<template>
  <div class="mt-3 position-relative deck-container">
    <deck-background :currentCard="currentCard" :ended="ended"/>

    <card-and-choices :currentCard="currentCard" @goNext="goNext" v-if="shown"/>
  </div>
</template>

<script>
import CardAndChoices from '@/components/cards/CardAndChoices'
import DeckBackground from '@/components/cards/DeckBackground'
import { mapMutations } from 'vuex'

export default {
  name: 'deck',
  components: { CardAndChoices, DeckBackground },
  props: ['deck'],
  data () {
    return {
      cardIndex: 0,
      shown: false,
      ended: false
    }
  },
  computed: {
    currentCard () {
      return this.deck ? this.deck[this.cardIndex] : {}
    }
  },
  methods: {
    ...mapMutations(['setBotMessage']),
    goNext () {
      if (this.cardIndex < this.deck.length - 1) {
        this.shown = false
        this.cardIndex += 1
        this.$nextTick(() => {
          this.shown = true
        })
        this.$emit('goNext')
      } else {
        this.ended = true
      }
    }
  },
  mounted () {
    setTimeout(() => {
      this.shown = true
    }, 500)
  },
  watch: {
    currentCard (newCard) {
      this.setBotMessage(newCard.botMessage)
    }
  }
}
</script>

<style scoped>
html,
body {
  overscroll-behavior-y: contain;
}

.deck-container {
  min-height: calc(var(--card_height) + 48 * 2);
}
</style>
